/* aer4d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aer4d_c(integer *n, doublereal *eps1, doublereal *d__,
        doublereal *e, doublereal *e2, doublereal *lb, doublereal *ub, 
        integer *mm, integer *m, doublereal *w, integer *ind, integer *ierr, 
        doublereal *rv4, doublereal *rv5)
{
    /* Initialized data */

    static doublereal sys051 = 1.1107652e-16;

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2, d__3;

    /* Local variables */
    static integer i__, j, k, l, p, q, r__, s;
    static doublereal u, v;
    static integer m1, m2;
    static doublereal t1, t2, x0, x1;
    static integer ii;
    static doublereal machep, xu;
    static integer isturm, tag;

    /* Parameter adjustments */
    --rv5;
    --rv4;
    --e2;
    --e;
    --d__;
    --ind;
    --w;

    /* Function Body */
/* ********** */
    machep = sys051;
    *ierr = 0;
    tag = 0;
    t1 = *lb;
    t2 = *ub;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* ********** */
        if (i__ == 1) {
            goto L1;
        }
        if ((d__1 = e[i__], abs(d__1)) > machep * ((d__2 = d__[i__], abs(d__2)
                ) + (d__3 = d__[i__ - 1], abs(d__3)))) {
            goto L2;
        }
L1:
        e2[i__] = 0.;
L2:
        ;
    }
/* ********** */
    p = 1;
    q = *n;
    x1 = *ub;
    isturm = 1;
    goto L17;
L3:
    *m = s;
    x1 = *lb;
    isturm = 2;
    goto L17;
L4:
    *m -= s;
    if (*m > *mm) {
        goto L31;
    }
    q = 0;
    r__ = 0;
/* ********** */
L5:
    if (r__ == *m) {
        goto L32;
    }
    ++tag;
    p = q + 1;
    xu = d__[p];
    x0 = d__[p];
    u = 0.;
    i__1 = *n;
    for (q = p; q <= i__1; ++q) {
        x1 = u;
        u = 0.;
        v = 0.;
        if (q == *n) {
            goto L6;
        }
        u = (d__1 = e[q + 1], abs(d__1));
        v = e2[q + 1];
L6:
/* Computing MIN */
        d__1 = d__[q] - (x1 + u);
        xu = min(d__1,xu);
/* Computing MAX */
        d__1 = d__[q] + (x1 + u);
        x0 = max(d__1,x0);
        if (v == 0.) {
            goto L8;
        }
/* L7: */
    }
L8:
/* Computing MAX */
    d__1 = abs(xu), d__2 = abs(x0);
    x1 = max(d__1,d__2) * machep;
    if (*eps1 <= 0.) {
        *eps1 = -x1;
    }
    if (p != q) {
        goto L9;
    }
/* ********** */
    if (t1 > d__[p] || d__[p] >= t2) {
        goto L30;
    }
    m1 = p;
    m2 = p;
    rv5[p] = d__[p];
    goto L25;
L9:
    x1 *= (doublereal) (q - p + 1);
/* Computing MAX */
    d__1 = t1, d__2 = xu - x1;
    *lb = max(d__1,d__2);
/* Computing MIN */
    d__1 = t2, d__2 = x0 + x1;
    *ub = min(d__1,d__2);
    x1 = *lb;
    isturm = 3;
    goto L17;
L10:
    m1 = s + 1;
    x1 = *ub;
    isturm = 4;
    goto L17;
L11:
    m2 = s;
    if (m1 > m2) {
        goto L30;
    }
/* ********** */
    x0 = *ub;
    isturm = 5;
    i__1 = m2;
    for (i__ = m1; i__ <= i__1; ++i__) {
        rv5[i__] = *ub;
        rv4[i__] = *lb;
/* L12: */
    }
/* ********** */
    k = m2;
L13:
    xu = *lb;
/* ********** */
    i__1 = k;
    for (ii = m1; ii <= i__1; ++ii) {
        i__ = m1 + k - ii;
        if (xu >= rv4[i__]) {
            goto L14;
        }
        xu = rv4[i__];
        goto L15;
L14:
        ;
    }
L15:
    if (x0 > rv5[k]) {
        x0 = rv5[k];
    }
/* ********** */
L16:
    x1 = (xu + x0) * .5;
    if (x0 - xu <= machep * 2. * (abs(xu) + abs(x0)) + abs(*eps1)) {
        goto L24;
    }
/* ********** */
L17:
    s = p - 1;
    u = 1.;
    i__1 = q;
    for (i__ = p; i__ <= i__1; ++i__) {
        if (u != 0.) {
            goto L18;
        }
        v = (d__1 = e[i__], abs(d__1)) / machep;
        if (e2[i__] == 0.) {
            v = 0.;
        }
        goto L19;
L18:
        v = e2[i__] / u;
L19:
        u = d__[i__] - x1 - v;
        if (u < 0.) {
            ++s;
        }
/* L20: */
    }
    switch (isturm) {
        case 1:  goto L3;
        case 2:  goto L4;
        case 3:  goto L10;
        case 4:  goto L11;
        case 5:  goto L21;
    }
/* ********** */
L21:
    if (s >= k) {
        goto L23;
    }
    xu = x1;
    if (s >= m1) {
        goto L22;
    }
    rv4[m1] = x1;
    goto L16;
L22:
    rv4[s + 1] = x1;
    if (rv5[s] > x1) {
        rv5[s] = x1;
    }
    goto L16;
L23:
    x0 = x1;
    goto L16;
/* ********** */
L24:
    rv5[k] = x1;
    --k;
    if (k >= m1) {
        goto L13;
    }
/* ********** */
L25:
    s = r__;
    r__ = r__ + m2 - m1 + 1;
    j = 1;
    k = m1;
    i__1 = r__;
    for (l = 1; l <= i__1; ++l) {
        if (j > s) {
            goto L27;
        }
        if (k > m2) {
            goto L30;
        }
        if (rv5[k] >= w[l]) {
            goto L28;
        }
        i__2 = s;
        for (ii = j; ii <= i__2; ++ii) {
            i__ = l + s - ii;
            w[i__ + 1] = w[i__];
            ind[i__ + 1] = ind[i__];
/* L26: */
        }
L27:
        w[l] = rv5[k];
        ind[l] = tag;
        ++k;
        goto L29;
L28:
        ++j;
L29:
        ;
    }
L30:
    if (q < *n) {
        goto L5;
    }
    goto L32;
/* ********** */
L31:
    *ierr = *n * 3 + 1;
L32:
    *lb = t1;
    *ub = t2;
    return 0;
} /* aer4d_c */
